#define MAX_GRAMMAR 202
#define PHRASE_BASE 515
int gram[MAX_GRAMMAR] = {
    2,     2,   516,   515,     0,     1,     2,   517,   530,     4,     1,   523,     1,   518,     1,   519, 
    1,   520,     1,     4,   256,   512,    61,   513,     1,     2,   257,   512,     1,     7,   258,   512, 
   40,   521,    41,    61,   524,     1,     2,   512,   522,     2,     3,    44,   512,   522,     0,     1, 
    3,   512,    61,   524,     1,     2,   526,   525,     2,     3,   540,   526,   525,     0,     1,     2, 
  528,   527,     2,     3,   541,   528,   527,     0,     1,     2,   529,   531,     2,     1,    33,     0, 
    2,     1,    59,     0,     1,     2,   533,   532,     2,     2,   542,   533,     0,     1,     2,   535, 
  534,     2,     3,   543,   535,   534,     0,     1,     3,   536,   538,   537,     2,     1,   544,     0, 
    2,     3,   544,   538,   537,     0,     1,     2,   546,   539,     2,     3,   545,   546,   539,     0, 
    1,     2,   124,   124,     1,     2,    38,    38,     7,     2,    60,    62,     2,    60,    61,     1, 
   60,     2,    62,    61,     1,    62,     2,    33,    61,     1,    61,     2,     2,    60,    60,     2, 
   62,    62,     2,     1,    43,     1,    45,     2,     1,    42,     1,    47,     4,     3,    40,   524, 
   41,     4,   512,    40,   547,    41,     1,   512,     1,   549,     2,     2,   533,   548,     0,     2, 
    3,    44,   533,   548,     0,     2,     1,   513,     1,   514, 
};

#define MAX_KEYWORD 3
char *keyword[MAX_KEYWORD] = { // Keywords are based at 256
  "const", "word", "let", 
};

#define MAX_BIP 3
int BIP[MAX_BIP] = { // BIPs precede PHRASEs at 512 upwards
 1,  5,  3, 
};

#define MAX_PHRASE 38
#ifdef DEBUG_PARSER
// FOR DEBUGGING ONLY
char *phrasename[MAX_PHRASE] = { // Based at 512 upwards
  "IDENT", "NUM", "CHARLIT", "SSLIST", 
  "STATEMENT", "SIMPLE", "CONSTDECL", "VARDECL", 
  "DEFFN", "FORMALS", "RESTOFFORMALS", "SS", 
  "BOOLEXPR", "RESTOFBOOLTERM", "BOOLTERM", "RESTOFBOOLFACTOR", 
  "BOOLFACTOR", "OPTNOT", "OPTSEMI", "RELATION", 
  "RESTOFRELATION", "EXPR", "RESTOFEXPR", "SUM", 
  "OPTADDOP", "RESTOFSUM", "TERM", "RESTOFTERM", 
  "OROP", "ANDOP", "RELOP", "SHIFTOP", 
  "ADDOP", "MULOP", "FACTOR", "PARAMLIST", 
  "RESTOFPARAMLIST", "NUMBER", 
};
#endif /* DEBUG_PARSER */

int phrase_start[MAX_PHRASE-MAX_BIP] = {
    0,     5,     9,    18,    24,    28,    37,    41,    47,    52,    56,    62,    66, 
   72,    76,    80,    84,    88,    93,    97,   103,   108,   112,   118,   122,   128,   132,   136,   155, 
  162,   167,   172,   186,   191,   197, 
};

#define P_IDENT 512
#define P_NUM 513
#define P_CHARLIT 514
#define P_SSLIST 515
#define P_STATEMENT 516
#define P_SIMPLE 517
#define P_CONSTDECL 518
#define P_VARDECL 519
#define P_DEFFN 520
#define P_FORMALS 521
#define P_RESTOFFORMALS 522
#define P_SS 523
#define P_BOOLEXPR 524
#define P_RESTOFBOOLTERM 525
#define P_BOOLTERM 526
#define P_RESTOFBOOLFACTOR 527
#define P_BOOLFACTOR 528
#define P_OPTNOT 529
#define P_OPTSEMI 530
#define P_RELATION 531
#define P_RESTOFRELATION 532
#define P_EXPR 533
#define P_RESTOFEXPR 534
#define P_SUM 535
#define P_OPTADDOP 536
#define P_RESTOFSUM 537
#define P_TERM 538
#define P_RESTOFTERM 539
#define P_OROP 540
#define P_ANDOP 541
#define P_RELOP 542
#define P_SHIFTOP 543
#define P_ADDOP 544
#define P_MULOP 545
#define P_FACTOR 546
#define P_PARAMLIST 547
#define P_RESTOFPARAMLIST 548
#define P_NUMBER 549
