#include <stdio.h>
#include <stdlib.h>

static int instream = 0, outstream = 0;
FILE *infile = NULL, *outfile = NULL;

int trap (int mask)
{
   return (0);
}

void dosignal (int i, int j, int k)
{
   if (i == 0)
      exit (0);
   fprintf (stderr, "Unhandled signal %d %d %d\n", i, j, k);
   exit (1);
}

int rsym (void)
{
   int c;

   c = fgetc ((instream == 0 ? stdin : infile));
   return c;
}

void selin (int stream)
{
   instream = stream;
}

void selout (int stream)
{
   outstream = stream;
}

void psym (int c)
{
   fputc (c, (outstream == 0 ? stderr : outfile));
}

void xprompt (int c)
{
   fputc (c, stdout);
}

static int k;
static int p1;
static int p2;
void makespace (void)
{
   static int k;
   static int p1;
   static int p2;

   if (mainfp () - pp > 240)
      return;
   selout (mout);
   p1 = top;
   p2 = p1 + lbeg >> 1;
   if (code == 'C')
      p2 = lbeg;
   if (p2 == top)
      signal (15, p1, p2);
   do {
      k = a[p1];
      psym (k);
      p1 = p1 + 1;
      if (p1 < p2)
	 k = 0;
   }
   while (k != nl);
   selout (0);
   lbeg = top + lbeg - p1;
   p2 = pp;
   pp = top;
   for (;;) {
      if (p1 == p2)
	 return;
      a[pp] = a[p1];
      pp = pp + 1;
      p1 = p1 + 1;
   }
}
int main (int argc, char **argv)
{
   if (argc != 3) {
      fprintf (stderr, "syntax: %s infile outfile\n", argv[0]);
      exit (1);
   }
   if (strcmp (argv[1], argv[2]) == 0) {
      fprintf (stderr, "%s: output file cannot overwrite input file\n",
	       argv[0]);
      exit (1);
   }
   infile = fopen (argv[1], "r");
   if (infile == NULL) {
      fprintf (stderr, "%s: cannot read file '%s'\n", argv[0], argv[1]);
      exit (1);
   }
   outfile = fopen (argv[2], "w");
   if (outfile == NULL) {
      fprintf (stderr, "%s: cannot write file '%s'\n", argv[0], argv[2]);
      exit (1);
   }
   exit (0);
}
