#include <stdio.h>
#include <stdlib.h>

static int instream = 0, outstream = 0;
FILE *infile = NULL, *outfile = NULL;

int trap (int mask)
{
   return (0);
}

void dosignal (int i, int j, int k)
{
   if (i == 0)
      exit (0);
   fprintf (stderr, "Unhandled signal %d %d %d\n", i, j, k);
   exit (1);
}

int rsym (void)
{
   int c;

   c = fgetc ((instream == 0 ? stdin : infile));
   return c;
}

void selin (int stream)
{
   instream = stream;
}

void selout (int stream)
{
   outstream = stream;
}

void psym (int c)
{
   fputc (c, (outstream == 0 ? stderr : outfile));
}

void xprompt (int c)
{
   fputc (c, stdout);
}

int main (int argc, char **argv)
{
   if (argc != 3) {
      fprintf (stderr, "syntax: %s infile outfile\n", argv[0]);
      exit (1);
   }
   if (strcmp (argv[1], argv[2]) == 0) {
      fprintf (stderr, "%s: output file cannot overwrite input file\n",
	       argv[0]);
      exit (1);
   }
   infile = fopen (argv[1], "r");
   if (infile == NULL) {
      fprintf (stderr, "%s: cannot read file '%s'\n", argv[0], argv[1]);
      exit (1);
   }
   outfile = fopen (argv[2], "w");
   if (outfile == NULL) {
      fprintf (stderr, "%s: cannot write file '%s'\n", argv[0], argv[2]);
      exit (1);
   }

   selout (0);
   psym ('E');
   psym ('C');
   psym ('C');
   psym ('E');
   psym (' ');
   psym ('0');
   psym ('6');
   psym ('/');
   psym ('0');
   psym ('1');
   psym ('/');
   psym ('8');
   psym ('1');
   psym (nl);
   if (trap (1 << 9) != 0)
      goto eof;
   selout (0);
   pp = top - 1;
   break ();
   readline ();
 readco:
   fflush (0);
   xprompt ('>');
   if (in == sin)
      xprompt ('>');
   do {
      ci = cbase;
      ti = tbase;
      chain = 0;
      readitem ();
   }
   while (type == 1);
   if (type == 0)
      if (cmax != 0) {
	 c[cmax + 2] = num;
	 readitem ();
	 if (type != 1)
	    goto er2;
	 goto execute;
      }
   if (sym == '%') {
      readsym ();
      if (sym >= 96)
	 sym = sym - 32;
      code = sym;
      if (code < 'A')
	 goto er5;
      readitem ();
      i = symtype[code] >> 4;
   } else {
    nextunit:
      i = type & 15;
      if (i < 4)
	 goto er2;
      code = sym;
      text = 0;
      num = 1;
      readitem ();
   }
   if (i == 0)
      goto er5;
   if (i == 1) {
      if (code == 'A') {
	 selout (mout);
	 signal (0, 0, 0);
      }
      if (code == 'S') {
	 switchinputs ();
	 goto monitor;
      }
    eof:
      code = 'C';
      if (in == sin)
	 switchinputs ();
      for (;;) {
	 rightstar ();
	 if (fp == fend) {
	    selout (mout);
	    for (;;) {
	       if (top == pp)
		  signal (0, 0, 0);
	       psym (a[top]);
	       top = top + 1;
	    }
	 }
	 break ();
	 refresh ();
      }
   }
   if (i == 2) {
      i = (code - 'X' << 6) + 1;
      if (sym == '=') {
	 do {
	    readsym ();
	    if (sym != nl) {
	       stored[i] = sym;
	       if ((i & 63) == 0)
		  goto er6;
	       i = i + 1;
	    }
	 }
	 while (sym != nl);
	 stored[i] = 0;
	 goto readco;
      }
      for (;;) {
	 sym = stored[i];
	 if (sym == 0) {
	    psym (nl);
	    goto readco;
	 }
	 psym (sym);
	 i = i + 1;
      }
   }
   if (i == 3) {
      mon = 'M' - code;
      goto readco;
   }
   if (i == 4)
      if (type != 0)
	 num = 0;
   if (i <= 5) {
      code = (num << 7) + code;
      num = 1;
      if (type == 0)
	 readitem ();
   }
   if (i <= 6) {
      if (type != 3)
	 goto er4;
      text = ti;
      i = sym;
      for (;;) {
	 readsym ();
	 if (sym == nl) {
	    pend = sym;
	    i = sym;
	 }
	 if (sym == i) {
	    if (code != 'I')
	       if (code != 'S') {
		  if (sym == nl)
		     goto er4;
		  if (ti == text)
		     goto er4;
	       }
	    c[ti] = 0;
	    ti = ti - 1;
	    goto ri;
	 }
	 if (ti <= ci)
	    goto er6;
	 c[ti] = sym;
	 ti = ti - 1;
      }
   }
   if (i == 7) {
      case = 95;
      if (code == 'L')
	 case = 127;
      goto readco;
   }
   if (i == 8) {
      if (sym != '-')
	 goto nq;
      code = code + 10;
    ri:
      readitem ();
      goto rn;
   }
   if (i == 9) {
      unchain ();
      if (text == 0)
	 goto er3;
      c[text + 2] = num;
      text = text + 3;
   }
   if (i <= 10) {
    nq:
      if (type == 3)
	 goto er1;
    rn:
      if (type == 0)
	 readitem ();
      goto put;
   }
   if (i == 12)
      if (type == 1)
	 readitem ();
   if (i <= 12) {
      text = chain;
      chain = ci;
      num = 0;
   }
   if (i > 12)
      signal (14, 1, i);
 put:
   stack (code);
   stack (text);
   stack (num);
   if (ci + 4 >= ti)
      goto er6;
   if (type != 1)
      goto nextunit;
   unchain ();
   if (text != 0)
      goto er3;
   cmax = ci;
   stack (')');
   stack (cbase);
   stack (1);
   stack (0);
   goto execute;
 er1:
   psym (' ');
   psym (code);
 er2:
   code = sym;
   goto er5;
 er3:
   psym (' ');
   psym ('(');
   psym (')');
   goto er7;
 er4:
   psym (' ');
   psym ('T');
   psym ('e');
   psym ('x');
   psym ('t');
   psym (' ');
   psym ('f');
   psym ('o');
   psym ('r');
 er5:
   psym (' ');
   psym (code & 127);
   goto er7;
 er6:
   psym (' ');
   psym ('S');
   psym ('i');
   psym ('z');
   psym ('e');
 er7:
   psym ('?');
   psym (nl);
   if (ci != cbase)
      cmax = 0;
   for (;;) {
      if (sym == nl)
	 goto readco;
      readsym ();
   }
 execute:
   ci = cbase;
 get:
   code = c[ci] & 127;
   if (code == 0)
      goto monitor;
   text = c[ci + 1];
   num = c[ci + 2];
   ci = ci + 3;
 rep:
   num = num - 1;
   if (code == 'M')
      goto xm;
   if (code == 'W')
      goto xw;
   if (code == 'L')
      goto xl;
   if (code == 'R')
      goto xr;
   if (code == 'C')
      goto xc;
   if (code == '(')
      goto xlb;
   if (code == ',')
      goto xcomma;
   if (code == ')')
      goto xrb;
   if (code == '\\')
      goto no;
   if (code == 'J')
      goto xj;
   if (code == 'K')
      goto xk;
   if (code == 'P')
      goto xp;
   if (code == 'B')
      goto xb;
   if (code == 'G')
      goto xg;
   if (code == 'I')
      goto xi;
   if (code == 'S')
      goto xs;
   if (code == 'T')
      goto xt;
   if (code == 'D')
      goto xd;
   if (code == 'U')
      goto xu;
   if (code == 'F')
      goto xf;
   if (code == 'V')
      goto xv;
   if (code == 'O')
      goto xo;
   if (code == 'E')
      goto xe;
   signal (14, 2, code);
 ok:
   if (num == 0)
      goto get;
   if (num == stop)
      goto get;
   goto rep;
 no:
   if (num < 0)
      goto get;
   if (c[ci] == '\\') {
      ci = ci + 3;
      goto get;
   }
 skp:
   i = c[ci];
   if (i == '(')
      ci = c[ci + 1];
   ci = ci + 3;
   if (i != ',')
      if (i != ')') {
	 if (i != 0)
	    goto skp;
	 goto xer;
      }
   num = c[ci - 1] - 1;
   goto no;
 xer:
   psym ('F');
   psym ('a');
   psym ('i');
   psym ('l');
   psym ('e');
   psym ('d');
   psym (' ');
   if (code == 'O') {
      psym ('E');
      code = '-';
   } else if (code == 'W') {
      psym ('M');
      code = '-';
   }
   psym (code);
   if (text != 0) {
      psym ('"');
      do {
	 i = c[text];
	 if (i != 0)
	    psym (i);
	 text = text - 1;
      }
      while (i != 0);
      psym ('"');
   }
   psym (nl);
   print1 = 0;
 monitor:
   if (sym != nl)
      goto readco;
   if (mon < 0)
      goto readco;
   if (print1 == lend) {
      if (mon == 0)
	 goto readco;
      if (print2 == fp + pp)
	 goto readco;
   }
   num = 0;
   printline ();
   goto readco;
 xlb:
   c[text + 2] = num + 1;
   goto get;
 xrb:
   if (num == 0)
      goto get;
   if (num == stop)
      goto get;
   c[ci - 1] = num;
 xcomma:
   ci = text;
   goto get;
 xc:
   if (fp == lend)
      goto no;
   i = a[fp];
   if ((i & 95) >= 'A')
      if ((i & 95) <= 'Z')
	 if ((i & 32) != 0)
	    a[fp] = i - 32;
	 else
	    a[fp] = i + 32;
 xr:
   if (fp == lend)
      goto no;
   a[pp] = a[fp];
   pp = pp + 1;
   fp = fp + 1;
   goto ok;
 xl:
   if (pp == lbeg)
      goto no;
   if (in == sin)
      goto no;
   fp = fp - 1;
   pp = pp - 1;
   a[fp] = a[pp];
   ms = 0;
   goto ok;
 xe:
   if (fp == lend)
      goto no;
   fp = fp + 1;
   goto ok;
 xo:
   if (pp == lbeg)
      goto no;
   pp = pp - 1;
   goto ok;
 xv:

 xu:

 xd:
 xf:
   if (matched () == 0)
      goto no;
   if (code == 'U')
      pp = pp1;
   else if (code == 'D')
      fp = ml;
   goto ok;
 xt:
   if (matched () == 0)
      goto no;
   do {
      a[pp] = a[fp];
      pp = pp + 1;
      fp = fp + 1;
   }
   while (fp != ml);
   goto ok;
 xs:
   if (fp != ms)
      goto no;
   fp = ml;
 xi:
   makespace ();
   if (pp - lbeg + lend - fp > 80)
      goto no;
   i = text;
   for (;;) {
      if (c[i] == 0)
	 goto ok;
      a[pp] = c[i];
      pp = pp + 1;
      i = i - 1;
   }
 xg:
   fflush (0);
   xprompt (':');
   makespace ();
   i = rsym ();
   if (i == ':')
      goto no;
   leftstar ();
   if (i != nl)
      do {
	 a[pp] = i;
	 pp = pp + 1;
	 i = rsym ();
      }
      while (i != nl);
 xb:
   break ();
   goto ok;
 xp:
   printline ();
   if (num == 0)
      goto get;
 xm:
   rightstar ();
   if (fp == fend)
      goto no;
   break ();
 m1:
   refresh ();
   goto ok;
 xk:
   pp = lbeg;
   fp = lend;
 k1:
   if (fp == fend)
      goto no;
   goto m1;
 xj:
   rightstar ();
   if (pp - lbeg > 80)
      goto no;
   goto k1;
 xw:
   if (in == sin)
      goto no;
   makespace ();
   if (lbeg == top)
      goto no;
   lend = fp - pp + lbeg - 1;
   for (;;) {
      k = a[pp - 1];
      if (k == nl)
	 if (pp != lbeg) {
	    lbeg = pp;
	    ms = 0;
	    goto ok;
	 }
      fp = fp - 1;
      pp = pp - 1;
      a[fp] = k;
   }
   signal (0, 0, 0);
   exit (0);
}
