#include <stdio.h>
#include <stdlib.h>

static int instream = 0, outstream = 0;
FILE *infile = NULL, *outfile = NULL;

int trap (int mask)
{
   return (0);
}

void dosignal (int i, int j, int k)
{
   if (i == 0)
      exit (0);
   fprintf (stderr, "Unhandled signal %d %d %d\n", i, j, k);
   exit (1);
}

int rsym (void)
{
   int c;

   c = fgetc ((instream == 0 ? stdin : infile));
   return c;
}

void selin (int stream)
{
   instream = stream;
}

void selout (int stream)
{
   outstream = stream;
}

void psym (int c)
{
   fputc (c, (outstream == 0 ? stderr : outfile));
}

void xprompt (int c)
{
   fputc (c, stdout);
}

int main (int argc, char **argv)
{
   if (argc != 3) {
      fprintf (stderr, "syntax: %s infile outfile\n", argv[0]);
      exit (1);
   }
   if (strcmp (argv[1], argv[2]) == 0) {
      fprintf (stderr, "%s: output file cannot overwrite input file\n",
	       argv[0]);
      exit (1);
   }
   infile = fopen (argv[1], "r");
   if (infile == NULL) {
      fprintf (stderr, "%s: cannot read file '%s'\n", argv[0], argv[1]);
      exit (1);
   }
   outfile = fopen (argv[2], "w");
   if (outfile == NULL) {
      fprintf (stderr, "%s: cannot write file '%s'\n", argv[0], argv[2]);
      exit (1);
   }

   if (i < 0)
      goto eof exit (0);
}
